unit uVererbung3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TW = class(tObject)
  private
    FZahl : integer;
  public
    procedure SetZahl(a : integer);
    function GetZahl : integer;
    procedure wuerfele; virtual; abstract;
  end;

  TW4 = class(TW)
  public
    procedure wuerfele; override;
  end;

  TW6 = class(TW)
  public
    procedure wuerfele; override;
  end;

  TForm1 = class(TForm)
    bW4aktuell: TButton;
    bW6aktuell: TButton;
    lAugen: TLabel;
    bWuerfele: TButton;
    lAktuell: TLabel;
    bWAAktuell: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bW4aktuellClick(Sender: TObject);
    procedure bW6aktuellClick(Sender: TObject);
    procedure bWuerfeleClick(Sender: TObject);
    procedure bWAAktuellClick(Sender: TObject);
  private
    w4    : TW4;
    w6    : TW6;
    wA,w  : TW;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

procedure TW.SetZahl(a : integer);
begin
  FZahl := a;
end;

function TW.GetZahl : integer;
begin
  result := FZahl;
end;

{
procedure TW.wuerfele;
begin
  setZahl(0);
end;
}

procedure TW4.wuerfele;
begin
  setZahl(Random(4)+1);
end;


procedure TW6.wuerfele;
begin
  setZahl(Random(6)+1);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  w4 := TW4.Create; w4.wuerfele;
  w6 := TW6.Create; w6.wuerfele;
  wA := TW.Create;
  w := wA;
  lAktuell.caption := 'wA ist aktueller Wrfel';
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  w4.Free; w6.Free; wA.Free;
end;

procedure TForm1.bW4aktuellClick(Sender: TObject);
begin
  w := w4;
  lAktuell.caption := 'w4 ist aktueller Wrfel';
end;

procedure TForm1.bW6aktuellClick(Sender: TObject);
begin
  w := w6;
  lAktuell.caption := 'w6 ist aktueller Wrfel';
end;

procedure TForm1.bWAAktuellClick(Sender: TObject);
begin
  w := wA;
  lAktuell.caption := 'wA ist aktueller Wrfel';
end;

procedure TForm1.bWuerfeleClick(Sender: TObject);
begin
  w.wuerfele;
  lAugen.Caption := IntToStr(w.GetZahl);
end;



end.
